/* TABS8
 * More file functions
 */

#include <types.h>
#include <syscalls.h>
#include <files.h>
#include <blkerrcodes.h>

EXTERN struct fcb **ppfcbs;
EXTERN uint maxfiles;			/* Number of file control blocks */

/*
 * System call 142: truncate a file in place
 */

_ftruncate(fd)
{
	register int fcbnum;
	register struct fcb *fcbptr;

	if (fd >= 0x80)
		fixfd(&fd);		/* Convert STDIN, STDOUT, STDERR */

	if (fd < NIODRIVERS)
	{	/* Character device */
		return 0;
	}

	fcbnum = fd - NIODRIVERS;

	if (fcbnum >= maxfiles)
		return BEC_BADFD;
	fcbptr = ppfcbsfcbnum;
	if (!fcbptr)
		return BEC_FNOPEN;
	if (fcbptr->pipefcb)
		return 0;

	fsentry();

	if (fcbptr->openmode != O_RDWR)
	{
		retval = BEC_FNWOPEN;
		goto err;
	}

	bdvrnum = fcbptr->bdvrnum;
	bbufindex = fcbptr->file_pos & BSIZEM1;

